﻿UsePNGImageEncoder()
UseJPEGImageEncoder()

Enumeration;gadget
  #cs
  #sx0;spin
  #sy0;spin
  #list;combo
  #coline
EndEnumeration

Enumeration
  #menu_open
  #menu_savei
  #menu_quit
  #menu_axis
  #menu_legend
EndEnumeration


Structure sint
  y.b[256]
  x0.w
  y0.w
  color.l
  Name.s
EndStructure

Global NewList MyList.sint()

Procedure drawlist()
  StartDrawing(ImageOutput(0))
  va=127
  Box (0,0,256,256,RGB(va,va,va) )
  ForEach myList()
    For xx=0 To 255
      Box(xx+mylist()\x0,(mylist()\y0-mylist()\y[xx]),1,1,mylist()\color)
    Next xx
  Next
  
  If GetMenuItemState(0, #menu_axis)
    blk=208
    cax=RGB(blk,blk,blk)
    For i=0 To 15
      LineXY(i*16,0,i*16,255,cax)
      LineXY(0,i*16,255,i*16,cax)
    Next i
  EndIf
  
  StopDrawing()
  
  StartDrawing(CanvasOutput(#cs)) 
  DrawImage( ImageID(0),0,0 )
  StopDrawing()
EndProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
If OpenWindow(0,0,0,346,256,"Binary Data Chart 1.0a",#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CreateImage(0,256,256)
  CreateImage(1,80,20)
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#menu_open, "Open..."   +Chr(9)+"Ctrl+O")
    MenuItem(#menu_savei, "Save Image"   +Chr(9)+"Ctrl+S")
    MenuBar()
    MenuItem(#menu_quit, "Quit"  +Chr(9)+"Ctrl+Q")
    MenuTitle("View")
    MenuItem(#menu_axis, "Axis")
    MenuItem(#menu_legend, "Legend")
  EndIf
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Q, #menu_quit)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_S, #menu_savei)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #menu_open)
  
  
  CanvasGadget(#cs,0,0,256,256)
  EnableWindowDrop(#cs,#PB_Drop_Files,#PB_Drag_Copy)
  ComboBoxGadget(#list,256,0,80,20)
  SpinGadget(#sx0,256,25,60,20,-128,128,#PB_Spin_Numeric):SetGadgetText( #sx0,"0")
  SpinGadget(#sy0,256,50,60,20,-128,128,#PB_Spin_Numeric):SetGadgetText( #sy0,"0")
  ImageGadget( #coline,256,80,80,20,ImageID(1),#PB_Image_Raised )
  drawlist()
  ;SelectElement(mylist(), 0)
  
  Pattern = 0; for saveimage
  
  Drag = #False
  isquit=0
  pos=-1
  Repeat
    Event = WaitWindowEvent()
    
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    
    pos=GetGadgetState(#list)
    Select Event
      Case #PB_Event_CloseWindow
        isquit=1
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_axis :
            SetMenuItemState(0, #menu_axis, 1-GetMenuItemState(0, #menu_axis))
            drawlist()
            
          Case #menu_quit : isquit=1
          Case #menu_open : ;Debug "Menu open"
            File$ = OpenFileRequester("Please choose file to load", GetCurrentDirectory(), "Binary (*.bin)|*.bin|Any (*.*)|*.*", 0)
            If File$
              AddElement( MyList() )
              If ReadFile(0,File$)
                mylist()\Name=GetFilePart(file$)
                AddGadgetItem(#list,-1,GetFilePart(file$))
                mylist()\x0=0
                mylist()\y0=128
                mylist()\color=0
                For j=0 To 255
                  mylist()\y[j]=ReadByte(0)
                Next j
                CloseFile(0)
              Else
                MessageRequester("Title","Error",#PB_MessageRequester_Ok)
              EndIf
              drawlist()
              If pos<=0
                SetGadgetState(#list,0)
              EndIf
            EndIf
            
          Case #menu_savei :; Debug "Menu saveimage"
            File$ = OpenFileRequester("Please choose file to load", GetCurrentDirectory(), "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|PNG (*.png)|*.png", Pattern)
            If File$
              ; MessageRequester("Information", "You have selected following file:" + Chr(10) + File$, 0)
              Pattern = SelectedFilePattern()
              ;Debug Pattern;0-bmp,1-jpg;2-png
              Select Pattern
                Case 0:SaveImage(0,File$+".bmp")
                Case 1:SaveImage(0,File$+".jpg",#PB_ImagePlugin_JPEG)
                Case 2:SaveImage(0,File$+".png",#PB_ImagePlugin_PNG)
              EndSelect
              ;              Else
              ;                MessageRequester("Information", "The requester was canceled.", 0)
            EndIf
            
            
        EndSelect
        
      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case #cs:
            Select EventType()
              Case #PB_EventType_LeftButtonDown
                If pos>=0
                  xb=GetGadgetAttribute(#cs, #PB_Canvas_MouseX)
                  yb=GetGadgetAttribute(#cs, #PB_Canvas_MouseY)
                  Drag = #True
                  SelectElement(mylist(), pos)
                  x00=mylist()\x0
                  y00=mylist()\y0
                EndIf
                ;EndIf
              Case #PB_EventType_LeftButtonUp
                Drag = #False
              Case #PB_EventType_MouseMove;If EventType()=#PB_EventType_MouseMove And GetGadgetAttribute(#cs, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
                If Drag
                  xe=GetGadgetAttribute(#cs, #PB_Canvas_MouseX)
                  ye=GetGadgetAttribute(#cs, #PB_Canvas_MouseY)
                  If pos>=0
                    SelectElement(mylist(), pos)
                    mylist()\x0=x00+xe-xb
                    mylist()\y0=y00+ye-yb
                    SetGadgetState(#sx0,mylist()\x0)
                    SetGadgetState(#sy0,mylist()\y0)
                    drawlist()
                  EndIf
                EndIf
                ;EndIf
                
            EndSelect 
          Case #sy0:
            If pos>=0
              SelectElement(mylist(), pos)
              mylist()\y0=GetGadgetState(#sy0)
              drawlist()
            EndIf
            
          Case #sx0:
            If pos>=0
              SelectElement(mylist(), pos)
              mylist()\x0=GetGadgetState(#sx0)
              drawlist()
            EndIf
          Case #coline:
            ;pos=GetGadgetState(#list)
            If pos>=0
              If EventType()=#PB_EventType_LeftClick
                SelectElement(mylist(), pos)
                Color = ColorRequester(mylist()\color)
                If Color > -1
                  mylist()\color=Color
                  StartDrawing( ImageOutput(1) )
                  va=127
                  Box(0,0,80,20,RGB(va,va,va))
                  LineXY(0,10,80,10,mylist()\color)
                  StopDrawing()
                  SetGadgetState(#coline,ImageID(1))
                  drawlist()
                EndIf
              EndIf
            EndIf
            
          Case #list:
            ;pos=GetGadgetState(#list)
            SelectElement(mylist(), pos)
            SetGadgetState(#sx0,mylist()\x0)
            SetGadgetState(#sy0,mylist()\y0)
            StartDrawing( ImageOutput(1) )
            va=127
            Box(0,0,80,20,RGB(va,va,va))
            LineXY(0,10,80,10,mylist()\color)
            StopDrawing()
            SetGadgetState(#coline,ImageID(1))
        EndSelect
        
      Case #PB_Event_WindowDrop
        Files$ = EventDropFiles()
        Count  = CountString(Files$, Chr(10)) + 1
        For ii = 1 To Count
          File$ = StringField(Files$, ii, Chr(10))
          AddElement( MyList() )
          If ReadFile(0,File$)
            mylist()\Name=GetFilePart(file$)
            AddGadgetItem(#list,-1,GetFilePart(file$))
            mylist()\x0=0
            mylist()\y0=128
            mylist()\color=0
            For j=0 To 255
              mylist()\y[j]=ReadByte(0)
            Next j
            CloseFile(0)
          Else
            MessageRequester("Title","Error",#PB_MessageRequester_Ok)
          EndIf
          drawlist()
        Next ii
    EndSelect
  Until isquit;Event=#PB_Event_CloseWindow 
EndIf

ClearList( MyList() )
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 57
; FirstLine = 49
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = sinview.ico
; Executable = sinview.exe